# ConfigObject
Date: 2012-06-29

com.typesafe.config

## Interface ConfigObject

All Superinterfaces:
  ConfigMergeable, ConfigValue, Map<String,ConfigValue>

    public interface ConfigObject
    extends ConfigValue, Map<String,ConfigValue>

Subtype of `ConfigValue` representing an object (dictionary, map) value, as in JSON's `{ "a" : 42 }` syntax.

`ConfigObject` implements `java.util.Map<String, ConfigValue>` so you can use it like a regular Java map. Or call `unwrapped()` to unwrap the map to a map with plain Java values rather than `ConfigValue`.

Like all `ConfigValue` subtypes, `ConfigObject` is immutable. This makes it threadsafe and you never have to create "defensive copies." The mutator methods from `Map` all throw `UnsupportedOperationException`.

The `ConfigValue.valueType()` method on an object returns `ConfigValueType.OBJECT`.

In most cases you want to use the `Config` interface rather than this one. Call `toConfig()` to convert a `ConfigObject` to a `Config`.

The API for a `ConfigObject` is in terms of keys, while the API for a `Config` is in terms of path expressions. Conceptually, `ConfigObject` is a tree of maps from keys to values, while a `ConfigObject` is a one-level map from paths to values.

A `ConfigObject` may contain null values, which will have `ConfigValue.valueType()` equal to `ConfigValueType.NULL`. If `get()` returns Java's null then the key was not present in the parsed file (or wherever this value tree came from). If `get()` returns a `ConfigValue` with type `ConfigValueType#NULL` then the key was set to null explicitly in the config file.

Do not implement `ConfigObject`; it should only be implemented by the config library. Arbitrary implementations will not work because the library internals assume a specific concrete implementation. Also, this interface is likely to grow new methods over time, so third-party implementations will break.

### Nested Class Summary

### Nested classes/interfaces inherited from interface java.util.Map

`Map.Entry<K,V>`

### Method Summary

Methods
`ConfigValue` `get(Object key)` Gets a `ConfigValue` at the given key, or returns null if there is no value.
`Config` `toConfig()` Converts this object to a `Config` instance, enabling you to use path expressions to find values in the object.
`Map<String,Object>` `unwrapped()` Recursively unwraps the object, returning a map from String to whatever plain Java values are unwrapped from the object's values.
`ConfigObject` `withFallback(ConfigMergeable other)` Returns a new value computed by merging this value with another, with keys in this value "winning" over the other one.

### Methods inherited from interface com.typesafe.config.ConfigValue

`origin, render, valueType`

### Methods inherited from interface java.util.Map

`clear, containsKey, containsValue, entrySet, equals, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

### Method Detail

#### toConfig

    Config toConfig()

Converts this object to a `Config` instance, enabling you to use path expressions to find values in the object. This is a constant-time operation (it is not proportional to the size of the object).

Returns:
  a `Config` with this object as its root

#### unwrapped

    Map<String,Object> unwrapped()

Recursively unwraps the object, returning a map from String to whatever plain Java values are unwrapped from the object's values.

Specified by:
  `unwrapped` in interface `ConfigValue`
Returns:
  a `Map` containing plain Java objects

#### withFallback

    ConfigObject withFallback(ConfigMergeable other)

Description copied from interface: `ConfigMergeable`
Returns a new value computed by merging this value with another, with keys in this value "winning" over the other one. Only `ConfigObject` and `Config` instances do anything in this method (they need to merge the fallback keys into themselves). All other values just return the original value, since they automatically override any fallback.

The semantics of merging are described in the spec for HOCON.

Note that objects do not merge "across" non-objects; if you write `object.withFallback(nonObject).withFallback(otherObject)`, then `otherObject` will simply be ignored. This is an intentional part of how merging works. Both non-objects, and any object which has fallen back to a non-object, block subsequent fallbacks.

Specified by:
  `withFallback` in interface `ConfigMergeable`
Specified by:
  `withFallback` in interface `ConfigValue`
Parameters:
  `other` - an object whose keys should be used if the keys are not present in this one
Returns:
  a new object (or the original one, if the fallback doesn't get used)

#### get

    ConfigValue get(Object key)

Gets a `ConfigValue` at the given key, or returns null if there is no value. The returned `ConfigValue` may have `ConfigValueType.NULL` or any other type, and the passed-in key must be a key in this object, rather than a path expression.

Specified by:
  `get` in interface `Map<String,ConfigValue>`
Parameters:
  `key` - key to look up
Returns:
  the value at the key or null if none